<?php
/**
 * This example shows settings to use when sending via Google's Gmail servers.
 */

$data = array(
  'debug_level' => 1,
  'smtp_server' => '127.0.0.1',
  'smtp_port' => 3333,
  // 'smtp_server' => 'smtp.qq.com',
  // 'smtp_secure' => 'tls',
  // 'smtp_port' => 587,
  'smtp_user' => 'ivincentwang@qq.com',
  'smtp_pass' => "mmmmmmmmm",
  'from_addr' => 'ivincentwang@qq.com',
  'from_name' => 'Vincent Wang',
  'cc_addr' => 'vincent@easyio.com',
  'cc_name' => 'Vincent Wang',
  'to_addr' => 'linsong.qizi@gmail.com',
  'to_name' => 'Linsong Qizi',
  'subject' => 'PHPMailer tls tunnel test by qqmail',
  'content' => "tls tunnel test blah blah",
  'attachments' => array('class.smtp.php')
);

//validate input
$required_keys = array('smtp_server', 'from_addr', 'to_addr', 'subject');
foreach($required_keys as $key) {
  if (empty($data[$key])) {
    die("ERROR : missing parameter '" . $key . "'");
  }
}

//SMTP needs accurate times, and the PHP time zone MUST be set
//This should be done in your php.ini, but this is how to do it if you don't have access to that
date_default_timezone_set('Etc/UTC');

require 'class.phpmailer.php';
require 'class.smtp.php';

//Create a new PHPMailer instance
$mail = new PHPMailer;

//Tell PHPMailer to use SMTP
$mail->isSMTP();

//Enable SMTP debugging
// 0 = off (for production use)
// 1 = client messages
// 2 = client and server messages
$mail->SMTPDebug = $data['debug_level'];

//Ask for HTML-friendly debug output
$mail->Debugoutput = 'html';

//Set the hostname of the mail server
$mail->Host = $data['smtp_server'];
// use
// $mail->Host = gethostbyname('smtp.gmail.com');
// if your network does not support SMTP over IPv6

//Set the SMTP port number - 587 for authenticated TLS, a.k.a. RFC4409 SMTP submission
$mail->Port = $data['smtp_port'];

//Set the encryption system to use - ssl (deprecated) or tls
$mail->SMTPSecure = $data['smtp_secure'];

$mail->SMTPOverTLSTunnel = $data['smtp_over_tls_tunnel'];

//Whether to use SMTP authentication
$mail->SMTPAuth = !empty($data['smtp_user']) && !empty($data['smtp_pass']);

//Username to use for SMTP authentication - use full email address for gmail
$mail->Username = $data['smtp_user'];

//Password to use for SMTP authentication
$mail->Password = $data['smtp_pass'];

//Set who the message is to be sent from
$mail->setFrom($data['from_addr'], $data['from_name']);

//Set cc data
if (!empty($data['cc_addr']))
  $mail->addCC($data['cc_addr'], $data['cc_name']);

//Set an alternative reply-to address
$mail->addReplyTo($data['from_addr'], $data['from_name']);

//Set who the message is to be sent to
$mail->addAddress($data['to_addr'], $data['to_name']);

//Set the subject line
$mail->Subject = $data['subject'];

//Read an HTML message body from an external file, convert referenced images to embedded,
//convert HTML into a basic plain-text alternative body
//$mail->msgHTML(file_get_contents('contents.html'), dirname(__FILE__));
$mail->msgHTML($data['content']);

//Replace the plain text body with one created manually
$mail->AltBody = 'This is a plain-text message body';

//Add Attachments
foreach($data['attachments'] as $path)
  $mail->addAttachment($path);

//send the message, check for errors
if (!$mail->send()) {
    echo "ERROR : " . $mail->ErrorInfo;
} else {
    echo "SUCCESS";
}
