<?php // vim: filetype=php

error_log(" * create table 'users' ...");
$db->exec(<<<EOD
  CREATE TABLE users (
    id INTEGER PRIMARY KEY AUTOINCREMENT,
    name varchar(255) NOT NULL UNIQUE,
    salt char(16) NOT NULL,
    checksum char(56) NOT NULL,
    is_admin char(1) DEFAULT 'f',
    created_at datetime default current_timestamp
  );
EOD
);

error_log(" * create admin user ...");
$salt = substr(str_shuffle("0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"), 0, 16); 
$default_password = (function_exists("isOEM") && isOEM()) ? "hellospt" : "hellocpt";
$checksum = sha1($default_password . $salt);
$db->exec(<<<EOD
  INSERT INTO users (name, salt, checksum, is_admin) VALUES('admin', '$salt', '$checksum', 't');
EOD
);

error_log(" * create table 'permissions' ...");
$db->exec(<<<EOD
  CREATE TABLE permissions (
    id INTEGER PRIMARY KEY AUTOINCREMENT,
    user_id INTEGER NOT NULL,
    path varchar(255) NOT NULL,
    readable char(1) DEFAULT 't',
    writable char(1) DEFAULT 't',
    created_at datetime default current_timestamp,
    FOREIGN KEY(user_id) REFERENCES users(id)
  );
EOD
);

?>
